# global -----
# les packages nécessaire
library(gitlabr)
library(DT)
library(shiny)
library(dplyr)
library(ggplot2)
library(plotly)
library(lubridate)
# remotes::install_github("spyrales/shinygouv")
library(shinygouv)
# remotes::install_github("spyrales/gouvdown")
library(gouvdown)
library(purrr)
library(httr)
library(jsonlite)


load("datamart_gitlabr.RData")
# ## parametres connexion gitlab-forge
gitlab_url <- "https://gitlab-forge.din.developpement-durable.gouv.fr"
token <- Sys.getenv("GITLAB_COM_TOKEN")
# initialisation de connexion pour GitlabR
gitlabr::set_gitlab_connection(gitlab_url = gitlab_url, #adresse internet
                               private_token = token) # Token personel pour connexion

# TO DO : A passer dans un script à part, à ranger dans data-raw
#
# # attention j'ai du modifier le filtre puisque les variable ne correspondait plus a ce de la veille on va peut etre partire sur le select()
# group <- gitlabr::gl_list_group_projects(group_id = 1013, max_page = 10)
# group <- group %>%  dplyr::select(id,name,created_at,star_count,last_activity_at,open_issues_count,updated_at,description,contains("members")) # _links.members
#
# # premier filtre pour les groupes
# groupf <- (group[as.numeric(group$open_issues_count) != 0, ])
#
# groupf$open_issues_count <- as.numeric(groupf$open_issues_count)
# # choix par identifiant de projet
# choice <- groupf$id %>% setNames(groupf$name)
#
#
# #identifier les variables disponible
# var_group <- names(gl_list_group_projects(group_id = 1013, max_page = 10))
# var_issue <- names(gl_list_issues(project = 23034))
#
# # parcourir la liste des identifiants ----
# resultats <- base::lapply(groupf$id, function(x) {
#   base::return(x) # La fonction doit retourner une valeur pour fonctionner
# })
#
# #creation du df pour le journal d'activité ----
#
# final_table <- resultats %>%
#   purrr::map_dfr(gl_list_issues)
#
# final_table <- final_table  %>%dplyr::mutate(id = project_id) %>%
#   dplyr::select(id,project_id,title,description,state,created_at,updated_at,labels,labels1,labels2,labels3,assignees.username,assignees.state,author.username,type,confidential,references.short,closed_at,closed_by.username)
#
# final_table <- final_table %>%
#   left_join(select(groupf,id,name),by = "id") %>% dplyr::select(name,project_id,title,description,state,created_at,updated_at,labels,labels1,labels2,labels3,assignees.username,assignees.state,author.username,type,confidential,references.short,closed_at,closed_by.username)
#
# # fonction API ----
# # Fonction pour récupérer les événements GitLab pour un projet
# get_gitlab_events <- function(project_id, event_type = NULL) {
#   url <- paste0(gitlab_url, "/api/v4/projects/", project_id, "/events")
#   headers <- add_headers(`PRIVATE-TOKEN` = token)
#
#   # Construire la requête en fonction du type d'événement souhaité
#   params <- list(per_page = 100)  # Limite à 100 événements par requête
#   if (!is.null(event_type)) {
#     params[["action"]] <- event_type
#   }
#
#   response <- GET(url, headers, query = params)
#   httr::stop_for_status(response)
#
#   if (status_code(response) != 200) {
#     stop("Échec de la récupération des données pour le projet ", project_id, " : ", content(response, "text"))
#   }
#
#   events <- fromJSON(content(response, "text"), flatten = TRUE)
#   events$project_id <- project_id  # Ajouter l'identifiant du projet pour le suivi
#   return(events)
# }
# # Fonction pour récupérer les événements pour plusieurs projets----
# get_events_for_projects <- function(project_ids, event_type = NULL) {
#   all_events <- list()
#
#   for (project_id in project_ids) {
#     cat("Récupération des événements pour le projet : ", project_id, "\n")
#     events <- tryCatch(
#       {
#         get_gitlab_events(project_id, event_type)
#       },
#       error = function(e) {
#         message("Erreur lors de la récupération des événements pour le projet ", project_id, " : ", e$message)
#         return(NULL)  # Retourner NULL en cas d'erreur pour ce projet
#       }
#     )
#     if (!is.null(events)) {
#       all_events[[as.character(project_id)]] <- events
#     }
#   }
#
#   all_events_df <- bind_rows(all_events, .id = "project_id")
#   return(all_events_df)
# }
# # Liste des identifiants de projets
# project_ids <- resultats  # Remplacez par vos identifiants de projets
#
# # Récupérer tous les événements pour tous les projets
# all_events <- get_events_for_projects(project_ids)
# # Convertir les données en un DataFrame
# all_events_df <- as_tibble(all_events)
#
# # pour le graphique temps/projet
data_chronol <- all_events_df %>%
  dplyr::transmute(
    id = project_id,
    type = dplyr::coalesce(paste(push_data.action, push_data.ref_type), paste(action_name, target_type)),
    temps = lubridate::as_datetime(created_at),
    info = dplyr::coalesce(push_data.commit_title, target_title, "")) %>%
  dplyr::left_join(select(groupf, id, name), by = "id") %>%
  dplyr::distinct() %>%
  dplyr::filter(!type %in% c("deleted", "pushed"))
rm(data)
save.image("datamart_gitlabr.RData")

# # Travail sur les types d'événements
# select(all_events_df, action_name, target_type, push_data.action, push_data.ref_type) %>%
#   distinct() %>%
#   replace_na(list(action_name = "", target_type = "", push_data.action = "", push_data.ref_type = "")) %>%
#   mutate(type2 = paste(push_data.action, push_data.ref_type),
#          type1 = paste(action_name, target_type)) %>%
#   arrange(action_name) %>%
#   View()
