ui <- shinygouv::navbarPage_dsfr(
  title = "Dataviz GitlabR",
  id = "nav",
  header = shinygouv::header_dsfr(
    intitule = c("DREAL", "Pays de la Loire"),
    nom_site_service = "Tableau de bord GitLab-Forge",
    baseline = "Les Projets du Centre de Services de la Donnée"
  ),
  # First tab Projet
  shinygouv::navbarPanel_dsfr(
    title = "Choix du projet à sélectionner",
    shinygouv::fluidRow_dsfr(
      shinygouv::column_dsfr(12, selectInput("ID1",
                                             label = h3("Nom du projet séléctionné"),
                                             choices = choice ),
                             extra_class = "fr-my-6w")
    ),
    shinygouv::fluidRow_dsfr(plotly::plotlyOutput(outputId = "issue_graph")),
    shinygouv::fluidRow_dsfr(
      shinygouv::column_dsfr(12,
                             DT::DTOutput(outputId = "tablef"),extra_class = "fr-mt-2w"))
  ),



  # Second tab Issue
  shinygouv::navbarPanel_dsfr(
    title = "Les issues du projet sélectionné",
    shinygouv::fluidRow_dsfr(
      shinygouv::column_dsfr(9,
                             shiny::textOutput("issue_nbr"),
                             # Adding space to the column
                             # https://www.systeme-de-design.gouv.fr/elements-d-interface/fondamentaux-techniques/espacement
                             extra_class = "fr-my-6w"
      ),
      shinygouv::column_dsfr(3, shinygouv::dateRangeInput_dsfr(inputId = "daterange1",
                                                               label = "Date range:",
                                                               start = "2016-01-01",
                                                               separator = "à"),
                                                              extra_class = "fr-my-6w"),
      shinygouv::column_dsfr(12, DT::DTOutput(outputId = "issue")
      )
    )
  ),
  # third tab activity
  shinygouv::navbarPanel_dsfr(
    title = "Activité des projets",
    shinygouv::fluidRow_dsfr(
      shinygouv::column_dsfr(12, DT::DTOutput(outputId = "activity")
                             ,extra_class = "fr-my-6w")
      )
    ),
  #Fourth tab graph activity an time
  shinygouv::navbarPanel_dsfr(
    title = "Graphique des projets par durée",
    shinygouv::fluidRow_dsfr(
      shinygouv::column_dsfr(12, shinygouv::dateRangeInput_dsfr(inputId = "daterange",
                                         label = "Sélectionnez une période :",
                                         start = "2024-07-01",
                                         separator = "à"),
                  extra_class = "fr-my-6w"),
      shinygouv::column_dsfr(12,plotly::plotlyOutput("filteredPlot", height = "700px"),
                  extra_class = "fr-mt-1w")
    )
  )
  )


